//+------------------------------------------------------------------+
//|                                                       i-NASA.mq4 |
//|                                                      Version 4.0 |
//|                                     Copyright  2009, Goalkeeper |
//|                                   http://forum.forexpeoples.com/ |
//+------------------------------------------------------------------+
//|               |
//|                |
//|       .         |
//+------------------------------------------------------------------+
//|                                :                    |
//+------------------------------------------------------------------+
//|                                             |
//|                                                  spread swap.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//|       ,          |
//|   :                                          |
//|                                            . aka KimIV  |
//|                                             http://www.kimiv.ru  |
//+------------------------------------------------------------------+
#property copyright                   "Copyright  2009, Goalkeeper"
#property link                      "http://forum.forexpeoples.com/"
#property indicator_separate_window
//====    ====
extern string   __     = "   0.1  8.0";
extern double   Lot_01 = 0.50;   //   
extern double   Lot_02 = 1.00;   //   
extern double   Lot_03 = 2.00;   //   
extern double   Lot_04 = 3.00;   //   
extern string   ___    = " % ";
extern double   Risk   = 40.0;   //  %      
extern string   ____   = " %   ";
extern double   Plus   = 5.0;    //  %   
extern string   _____  = "   ";
extern int      PPips  = 20;     // -      
//====  ====
int      X01      = 3;           //    
int      StepX01  = 60;          //    1- 
int      X02      = 115;         //    
int      StepX02  = 100;         //    2- 
int      X03      = 245;         //    
int      StepX03  = 60;          //    3- 
int      X04      = 390;         //    
int      StepX04  = 110;         //    4- 
int      StepX05  = 95;          //    5-  .. 
int      StepX06  = 45;          //     
int      Y01      = 20;          //  Y  
//====  ====
color    Color1   = Gray;        //  
color    Color2   = Lime;        //   (+)
color    Color3   = Red;         //   (-)
color    Color4   = Aqua;        //  
color    Color5   = Yellow;      //     (-)
color    Color6   = Magenta;     //     (+)
//====  ====
int      FontSize = 8;           //  
string   FontName = "Arial";     // 
string   ShortName = "NASA.";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
   {
   DeleteObjects();
   IndicatorShortName(ShortName);
   return(0);
   }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
   {
   DeleteObjects();
   return(0);
   }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
   DeleteObjects();
//====   ====
   double      swaplong, swapshort, dolg, profit, balance, depozit, free, BalPlus;
   double      percent_01, percent_02, percent_03, percent_04;
   double      pips_01, pips_02, pips_03, pips_04;
   double      PipsPlus_01, PipsPlus_02, PipsPlus_03, PipsPlus_04;
   double      Minus_01, Minus_02, Minus_03, Minus_04;
   double      PlusMinus_01, PlusMinus_02, PlusMinus_03, PlusMinus_04;
   int         spread, step, golova;
   color       ColorLot_01, ColorLot_02, ColorLot_03, ColorLot_04, ColorType, ColorProfit, ColorPips;
   string      type;
//====   ====
   int StepY   = MathCeil(1.5*FontSize);                                //   
   spread      = MarketInfo(Symbol(),13);                               //   
   step        = MarketInfo(Symbol(),14);                               //    -/-  
   swaplong    = NormalizeDouble(MarketInfo(Symbol(),18),2);            //      ( Buy)
   swapshort   = NormalizeDouble(MarketInfo(Symbol(),19),2);            //      ( Sell)
   golova      = AccountLeverage();                                     //  
   balance     = AccountBalance();                                      //  
   depozit     = AccountEquity();                                       //  
   free        = AccountFreeMargin();                                   //   

   datetime    d0 = StrToTime(TimeToStr(TimeCurrent(), TIME_DATE));
         while (TimeDayOfWeek(d0)<1 || TimeDayOfWeek(d0)>5) d0-=24*60*60;
   datetime    d1 = d0-24*60*60;
         while (TimeDayOfWeek(d1)<1 || TimeDayOfWeek(d1)>5) d1-=24*60*60;

   double      p0 = GetProfitFromDateInCurrency("", -1, -1, d0);        //    
   double      p1 = AccountProfit();                                    //    
   double      b1 = balance-p0;                                         //      
   double      p0_per = p0*100/b1;                                      //      
   double      p1_per = p1*100/b1;                                      //      

   dolg        = NormalizeDouble(MarketInfo(Symbol(),32),2);            //    1.0
   profit      = NormalizeDouble(MarketInfo(Symbol(),16),2);            //   1    1.0
   percent_01  = NormalizeDouble((dolg*Lot_01*100/balance),1);          //      Lot_01
   percent_02  = NormalizeDouble((dolg*Lot_02*100/balance),0);          //      Lot_02
   percent_03  = NormalizeDouble((dolg*Lot_03*100/balance),0);          //      Lot_03
   percent_04  = NormalizeDouble((dolg*Lot_04*100/balance),0);          //      Lot_04

   pips_01     = (profit*Lot_01*100)/balance;                           //    1     Lot_01
   pips_02     = (profit*Lot_02*100)/balance;                           //    1     Lot_02
   pips_03     = (profit*Lot_03*100)/balance;                           //    1     Lot_03
   pips_04     = (profit*Lot_04*100)/balance;                           //    1     Lot_04

   BalPlus     = b1*Plus/100;                                           //      ,      (Plus)
   PipsPlus_01 = NormalizeDouble(((BalPlus/(profit*Lot_01)+1)),0);      //  ,      (Plus)  Lot_01
   PipsPlus_02 = NormalizeDouble(((BalPlus/(profit*Lot_02)+1)),0);      //  ,      (Plus)  Lot_02
   PipsPlus_03 = NormalizeDouble(((BalPlus/(profit*Lot_03)+1)),0);      //  ,      (Plus)  Lot_03
   PipsPlus_04 = NormalizeDouble(((BalPlus/(profit*Lot_04)+1)),0);      //  ,      (Plus)  Lot_04

   Minus_01    = NormalizeDouble((p0/(profit*Lot_01)),0);               //  ,      (Plus)  Lot_01
   Minus_02    = NormalizeDouble((p0/(profit*Lot_02)),0);               //  ,      (Plus)  Lot_02
   Minus_03    = NormalizeDouble((p0/(profit*Lot_03)),0);               //  ,      (Plus)  Lot_03
   Minus_04    = NormalizeDouble((p0/(profit*Lot_04)),0);               //  ,      (Plus)  Lot_04
//====         ====
   PlusMinus_01 = 0;
      if (PipsPlus_01>=Minus_01)    PlusMinus_01   = PipsPlus_01 - Minus_01;
            else                    PlusMinus_01   = 0;
   PlusMinus_02 = 0;
      if (PipsPlus_02>=Minus_02)    PlusMinus_02   = PipsPlus_02 - Minus_02;
            else                    PlusMinus_02   = 0;
   PlusMinus_03 = 0;
      if (PipsPlus_03>=Minus_03)    PlusMinus_03   = PipsPlus_03 - Minus_03;
            else                    PlusMinus_03   = 0;
   PlusMinus_04 = 0;
      if (PipsPlus_04>=Minus_04)    PlusMinus_04   = PipsPlus_04 - Minus_04;
            else                    PlusMinus_04   = 0;

//====     %  ====
   double   RiskDepo = AccountBalance()*Risk/100;
   ColorLot_01 = Color2;
      if ((dolg*Lot_01)<RiskDepo)   ColorLot_01 = Color2;
            else                    ColorLot_01 = Color3;
   ColorLot_02 = Color2;
      if ((dolg*Lot_02)<RiskDepo)   ColorLot_02 = Color2;
            else                    ColorLot_02 = Color3;
   ColorLot_03 = Color2;
      if ((dolg*Lot_03)<RiskDepo)   ColorLot_03 = Color2;
            else                    ColorLot_03 = Color3;
   ColorLot_04 = Color2;
      if ((dolg*Lot_04)<RiskDepo)   ColorLot_04 = Color2;
            else                    ColorLot_04 = Color3;
//====    /  ====
   ColorProfit = Color2;
      if (depozit>=balance)         ColorProfit = Color2;
            else                    ColorProfit = Color3;
//====       ====
   ColorPips = Color5;
      if (p0_per<=Plus)             ColorPips   = Color5;
            else                    ColorPips   = Color6;
//====       ====
   if (IsDemo())  type = "DEMO";
      else        type = "REAL";
   if (IsDemo())  ColorType = Color3;
      else        ColorType = Color4;
//====   ====
   double   volotil_01, volotil_02, volotil_03;
   volotil_01  = (iHigh(NULL,1440,0)     - iLow(NULL,1440,0))      /Point;   // 
   volotil_02  = (iHigh(NULL,1440*7,0)   - iLow(NULL,1440*7,0))    /Point;   //   
   volotil_03  = (iHigh(NULL,1440*30,0)  - iLow(NULL,1440*30,0))   /Point;   //   
//====   ====
   ObjectCreate   ("i-NASA4_101", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_101", " :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_101", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_101", OBJPROP_XDISTANCE, X01);
   ObjectSet      ("i-NASA4_101", OBJPROP_YDISTANCE, Y01);

   ObjectCreate   ("i-NASA4_102", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_102", Symbol(), FontSize, FontName, Color4);
   ObjectSet      ("i-NASA4_102", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_102", OBJPROP_XDISTANCE, X01+StepX01);
   ObjectSet      ("i-NASA4_102", OBJPROP_YDISTANCE, Y01);
//====   ====
   ObjectCreate   ("i-NASA4_201", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_201", "/:", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_201", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_201", OBJPROP_XDISTANCE, X01);
   ObjectSet      ("i-NASA4_201", OBJPROP_YDISTANCE, Y01+StepY);

   ObjectCreate   ("i-NASA4_202", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_202", DoubleToStr(spread ,0)+" / "+DoubleToStr(step ,0), FontSize, FontName, Color4);
   ObjectSet      ("i-NASA4_202", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_202", OBJPROP_XDISTANCE, X01+StepX01);
   ObjectSet      ("i-NASA4_202", OBJPROP_YDISTANCE, Y01+StepY);
//====   BUY ====
   ObjectCreate   ("i-NASA4_301", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_301", " Buy :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_301", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_301", OBJPROP_XDISTANCE, X01);
   ObjectSet      ("i-NASA4_301", OBJPROP_YDISTANCE, Y01+2*StepY);

   ObjectCreate   ("i-NASA4_302", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_302", DoubleToStr(swaplong ,2), FontSize, FontName, ColorZero(swaplong));
   ObjectSet      ("i-NASA4_302", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_302", OBJPROP_XDISTANCE, X01+StepX01);
   ObjectSet      ("i-NASA4_302", OBJPROP_YDISTANCE, Y01+2*StepY);
//====   SELL ====
   ObjectCreate   ("i-NASA4_401", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_401", " Sell :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_401", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_401", OBJPROP_XDISTANCE, X01);
   ObjectSet      ("i-NASA4_401", OBJPROP_YDISTANCE, Y01+3*StepY);

   ObjectCreate   ("i-NASA4_402", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_402", DoubleToStr(swapshort ,2), FontSize, FontName, ColorZero(swapshort));
   ObjectSet      ("i-NASA4_402", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_402", OBJPROP_XDISTANCE, X01+StepX01);
   ObjectSet      ("i-NASA4_402", OBJPROP_YDISTANCE, Y01+3*StepY);
//====      ====
   ObjectCreate   ("i-NASA4_501", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_501", " :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_501", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_501", OBJPROP_XDISTANCE, X01);
   ObjectSet      ("i-NASA4_501", OBJPROP_YDISTANCE, Y01+4*StepY);

   ObjectCreate   ("i-NASA4_502", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_502", type + "  1:" +DoubleToStr(golova, 0), FontSize, FontName, ColorType);
   ObjectSet      ("i-NASA4_502", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_502", OBJPROP_XDISTANCE, X01+StepX01/1.6);
   ObjectSet      ("i-NASA4_502", OBJPROP_YDISTANCE, Y01+4*StepY);
//====    ====
   ObjectCreate   ("i-NASA4_103", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_103", "Hi - Lo  :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_103", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_103", OBJPROP_XDISTANCE, X02);
   ObjectSet      ("i-NASA4_103", OBJPROP_YDISTANCE, Y01);

   ObjectCreate   ("i-NASA4_104", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_104", DoubleToStr(volotil_01, 0), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_104", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_104", OBJPROP_XDISTANCE, X02+StepX02);
   ObjectSet      ("i-NASA4_104", OBJPROP_YDISTANCE, Y01);
//====     ====
   ObjectCreate   ("i-NASA4_203", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_203", "Hi - Lo   :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_203", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_203", OBJPROP_XDISTANCE, X02);
   ObjectSet      ("i-NASA4_203", OBJPROP_YDISTANCE, Y01+StepY);

   ObjectCreate   ("i-NASA4_204", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_204", DoubleToStr(volotil_02, 0), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_204", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_204", OBJPROP_XDISTANCE, X02+StepX02);
   ObjectSet      ("i-NASA4_204", OBJPROP_YDISTANCE, Y01+StepY);
//====     ====
   ObjectCreate   ("i-NASA4_303", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_303", "Hi - Lo   :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_303", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_303", OBJPROP_XDISTANCE, X02);
   ObjectSet      ("i-NASA4_303", OBJPROP_YDISTANCE, Y01+2*StepY);

   ObjectCreate   ("i-NASA4_304", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_304", DoubleToStr(volotil_03, 0), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_304", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_304", OBJPROP_XDISTANCE, X02+StepX02);
   ObjectSet      ("i-NASA4_304", OBJPROP_YDISTANCE, Y01+2*StepY);
//====    ====
   ObjectCreate   ("i-NASA4_403", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_403", ", %   :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_403", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_403", OBJPROP_XDISTANCE, X02);
   ObjectSet      ("i-NASA4_403", OBJPROP_YDISTANCE, Y01+3*StepY);

   ObjectCreate   ("i-NASA4_404", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_404", DoubleToStr(Risk,1), FontSize, FontName, Color3);
   ObjectSet      ("i-NASA4_404", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_404", OBJPROP_XDISTANCE, X02+StepX02);
   ObjectSet      ("i-NASA4_404", OBJPROP_YDISTANCE, Y01+3*StepY);
//====    ====
   ObjectCreate   ("i-NASA4_503", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_503", ", %   :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_503", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_503", OBJPROP_XDISTANCE, X02);
   ObjectSet      ("i-NASA4_503", OBJPROP_YDISTANCE, Y01+4*StepY);

   ObjectCreate   ("i-NASA4_504", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_504", DoubleToStr(Plus,1), FontSize, FontName, ColorPips);
   ObjectSet      ("i-NASA4_504", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_504", OBJPROP_XDISTANCE, X02+StepX02);
   ObjectSet      ("i-NASA4_504", OBJPROP_YDISTANCE, Y01+4*StepY);
//====    ====
   ObjectCreate   ("i-NASA4_105", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_105", " :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_105", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_105", OBJPROP_XDISTANCE, X03);
   ObjectSet      ("i-NASA4_105", OBJPROP_YDISTANCE, Y01);

   ObjectCreate   ("i-NASA4_106", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_106", DoubleToStr(balance, 2), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_106", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_106", OBJPROP_XDISTANCE, X03+StepX03);
   ObjectSet      ("i-NASA4_106", OBJPROP_YDISTANCE, Y01);
//====    ====
   ObjectCreate   ("i-NASA4_205", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_205", " :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_205", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_205", OBJPROP_XDISTANCE, X03);
   ObjectSet      ("i-NASA4_205", OBJPROP_YDISTANCE, Y01+StepY);

   ObjectCreate   ("i-NASA4_206", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_206", DoubleToStr(depozit, 2), FontSize, FontName, ColorProfit);
   ObjectSet      ("i-NASA4_206", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_206", OBJPROP_XDISTANCE, X03+StepX03);
   ObjectSet      ("i-NASA4_206", OBJPROP_YDISTANCE, Y01+StepY);
//====    ====
   ObjectCreate   ("i-NASA4_305", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_305", " :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_305", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_305", OBJPROP_XDISTANCE, X03);
   ObjectSet      ("i-NASA4_305", OBJPROP_YDISTANCE, Y01+2*StepY);

   ObjectCreate   ("i-NASA4_306", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_306", DoubleToStr(free, 2), FontSize, FontName, Color4);
   ObjectSet      ("i-NASA4_306", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_306", OBJPROP_XDISTANCE, X03+StepX03);
   ObjectSet      ("i-NASA4_306", OBJPROP_YDISTANCE, Y01+2*StepY);
//====      ====
   ObjectCreate   ("i-NASA4_405", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_405", " :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_405", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_405", OBJPROP_XDISTANCE, X03);
   ObjectSet      ("i-NASA4_405", OBJPROP_YDISTANCE, Y01+3*StepY);

   ObjectCreate   ("i-NASA4_406", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_406", DoubleToStr(p0, 0)+" ("+DoubleToStr(p0_per, 1)+"%)", FontSize, FontName, ColorZero(p0_per));
   ObjectSet      ("i-NASA4_406", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_406", OBJPROP_XDISTANCE, X03+StepX03);
   ObjectSet      ("i-NASA4_406", OBJPROP_YDISTANCE, Y01+3*StepY);
//====      ====
   ObjectCreate   ("i-NASA4_505", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_505", " :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_505", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_505", OBJPROP_XDISTANCE, X03);
   ObjectSet      ("i-NASA4_505", OBJPROP_YDISTANCE, Y01+4*StepY);

   ObjectCreate   ("i-NASA4_506", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_506", DoubleToStr(p1, 0)+" ("+DoubleToStr(p1_per, 1)+"%)", FontSize, FontName, ColorZero(p1_per));
   ObjectSet      ("i-NASA4_506", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_506", OBJPROP_XDISTANCE, X03+StepX03);
   ObjectSet      ("i-NASA4_506", OBJPROP_YDISTANCE, Y01+4*StepY);
//====    ====
   ObjectCreate   ("i-NASA4_121", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_121", "  :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_121", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_121", OBJPROP_XDISTANCE, X04);
   ObjectSet      ("i-NASA4_121", OBJPROP_YDISTANCE, Y01);

   ObjectCreate   ("i-NASA4_122", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_122", DoubleToStr(Lot_01, 2), FontSize, FontName, ColorLot_01);
   ObjectSet      ("i-NASA4_122", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_122", OBJPROP_XDISTANCE, X04+StepX04);
   ObjectSet      ("i-NASA4_122", OBJPROP_YDISTANCE, Y01);

   ObjectCreate   ("i-NASA4_123", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_123", DoubleToStr(Lot_02, 2), FontSize, FontName, ColorLot_02);
   ObjectSet      ("i-NASA4_123", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_123", OBJPROP_XDISTANCE, X04+StepX04+StepX05);
   ObjectSet      ("i-NASA4_123", OBJPROP_YDISTANCE, Y01);

   ObjectCreate   ("i-NASA4_124", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_124", DoubleToStr(Lot_03, 2), FontSize, FontName, ColorLot_03);
   ObjectSet      ("i-NASA4_124", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_124", OBJPROP_XDISTANCE, X04+StepX04+2*StepX05);
   ObjectSet      ("i-NASA4_124", OBJPROP_YDISTANCE, Y01);

   ObjectCreate   ("i-NASA4_125", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_125", DoubleToStr(Lot_04, 2), FontSize, FontName, ColorLot_04);
   ObjectSet      ("i-NASA4_125", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_125", OBJPROP_XDISTANCE, X04+StepX04+3*StepX05);
   ObjectSet      ("i-NASA4_125", OBJPROP_YDISTANCE, Y01);
//====    ====
   ObjectCreate   ("i-NASA4_221", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_221", "  :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_221", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_221", OBJPROP_XDISTANCE, X04);
   ObjectSet      ("i-NASA4_221", OBJPROP_YDISTANCE, Y01+StepY);

   ObjectCreate   ("i-NASA4_222", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_222", DoubleToStr(dolg*Lot_01, 2), FontSize, FontName, ColorLot_01);
   ObjectSet      ("i-NASA4_222", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_222", OBJPROP_XDISTANCE, X04+StepX04);
   ObjectSet      ("i-NASA4_222", OBJPROP_YDISTANCE, Y01+StepY);

   ObjectCreate   ("i-NASA4_223", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_223", DoubleToStr(dolg*Lot_02, 2), FontSize, FontName, ColorLot_02);
   ObjectSet      ("i-NASA4_223", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_223", OBJPROP_XDISTANCE, X04+StepX04+StepX05);
   ObjectSet      ("i-NASA4_223", OBJPROP_YDISTANCE, Y01+StepY);

   ObjectCreate   ("i-NASA4_224", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_224", DoubleToStr(dolg*Lot_03, 2), FontSize, FontName, ColorLot_03);
   ObjectSet      ("i-NASA4_224", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_224", OBJPROP_XDISTANCE, X04+StepX04+2*StepX05);
   ObjectSet      ("i-NASA4_224", OBJPROP_YDISTANCE, Y01+StepY);

   ObjectCreate   ("i-NASA4_225", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_225", DoubleToStr(dolg*Lot_04, 2), FontSize, FontName, ColorLot_04);
   ObjectSet      ("i-NASA4_225", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_225", OBJPROP_XDISTANCE, X04+StepX04+3*StepX05);
   ObjectSet      ("i-NASA4_225", OBJPROP_YDISTANCE, Y01+StepY);

   ObjectCreate   ("i-NASA4_322", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_322", " ("+DoubleToStr(percent_01, 1)+"%)", FontSize, FontName, ColorLot_01);
   ObjectSet      ("i-NASA4_322", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_322", OBJPROP_XDISTANCE, X04+StepX04+StepX06);
   ObjectSet      ("i-NASA4_322", OBJPROP_YDISTANCE, Y01+StepY);

   ObjectCreate   ("i-NASA4_323", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_323", " ("+DoubleToStr(percent_02, 1)+"%)", FontSize, FontName, ColorLot_02);
   ObjectSet      ("i-NASA4_323", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_323", OBJPROP_XDISTANCE, X04+StepX04+StepX05+StepX06);
   ObjectSet      ("i-NASA4_323", OBJPROP_YDISTANCE, Y01+StepY);

   ObjectCreate   ("i-NASA4_324", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_324", " ("+DoubleToStr(percent_03, 1)+"%)", FontSize, FontName, ColorLot_03);
   ObjectSet      ("i-NASA4_324", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_324", OBJPROP_XDISTANCE, X04+StepX04+2*StepX05+StepX06);
   ObjectSet      ("i-NASA4_324", OBJPROP_YDISTANCE, Y01+StepY);

   ObjectCreate   ("i-NASA4_325", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_325", " ("+DoubleToStr(percent_04, 1)+"%)", FontSize, FontName, ColorLot_04);
   ObjectSet      ("i-NASA4_325", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_325", OBJPROP_XDISTANCE, X04+StepX04+3*StepX05+StepX06);
   ObjectSet      ("i-NASA4_325", OBJPROP_YDISTANCE, Y01+StepY);

//====    1  ====
   ObjectCreate   ("i-NASA4_131", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_131", "+ / -   1  :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_131", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_131", OBJPROP_XDISTANCE, X04);
   ObjectSet      ("i-NASA4_131", OBJPROP_YDISTANCE, Y01+2*StepY);

   ObjectCreate   ("i-NASA4_132", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_132", DoubleToStr(profit*Lot_01, 2), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_132", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_132", OBJPROP_XDISTANCE, X04+StepX04);
   ObjectSet      ("i-NASA4_132", OBJPROP_YDISTANCE, Y01+2*StepY);

   ObjectCreate   ("i-NASA4_133", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_133", DoubleToStr(profit*Lot_02, 2), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_133", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_133", OBJPROP_XDISTANCE, X04+StepX04+StepX05);
   ObjectSet      ("i-NASA4_133", OBJPROP_YDISTANCE, Y01+2*StepY);

   ObjectCreate   ("i-NASA4_134", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_134", DoubleToStr(profit*Lot_03, 2), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_134", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_134", OBJPROP_XDISTANCE, X04+StepX04+2*StepX05);
   ObjectSet      ("i-NASA4_134", OBJPROP_YDISTANCE, Y01+2*StepY);

   ObjectCreate   ("i-NASA4_135", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_135", DoubleToStr(profit*Lot_04, 2), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_135", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_135", OBJPROP_XDISTANCE, X04+StepX04+3*StepX05);
   ObjectSet      ("i-NASA4_135", OBJPROP_YDISTANCE, Y01+2*StepY);

   ObjectCreate   ("i-NASA4_232", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_232", " ("+DoubleToStr(pips_01, 2)+"%)", FontSize, FontName, Color4);
   ObjectSet      ("i-NASA4_232", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_232", OBJPROP_XDISTANCE, X04+StepX04+StepX06);
   ObjectSet      ("i-NASA4_232", OBJPROP_YDISTANCE, Y01+2*StepY);

   ObjectCreate   ("i-NASA4_233", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_233", " ("+DoubleToStr(pips_02, 2)+"%)", FontSize, FontName, Color4);
   ObjectSet      ("i-NASA4_233", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_233", OBJPROP_XDISTANCE, X04+StepX04+StepX05+StepX06);
   ObjectSet      ("i-NASA4_233", OBJPROP_YDISTANCE, Y01+2*StepY);

   ObjectCreate   ("i-NASA4_234", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_234", " ("+DoubleToStr(pips_03, 2)+"%)", FontSize, FontName, Color4);
   ObjectSet      ("i-NASA4_234", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_234", OBJPROP_XDISTANCE, X04+StepX04+2*StepX05+StepX06);
   ObjectSet      ("i-NASA4_234", OBJPROP_YDISTANCE, Y01+2*StepY);

   ObjectCreate   ("i-NASA4_235", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_235", " ("+DoubleToStr(pips_04, 2)+"%)", FontSize, FontName, Color4);
   ObjectSet      ("i-NASA4_235", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_235", OBJPROP_XDISTANCE, X04+StepX04+3*StepX05+StepX06);
   ObjectSet      ("i-NASA4_235", OBJPROP_YDISTANCE, Y01+2*StepY);
//====    PPips  ====
   ObjectCreate   ("i-NASA4_141", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_141", "+ / -   "+DoubleToStr(PPips, 0)+"  :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_141", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_141", OBJPROP_XDISTANCE, X04);
   ObjectSet      ("i-NASA4_141", OBJPROP_YDISTANCE, Y01+3*StepY);

   ObjectCreate   ("i-NASA4_142", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_142", DoubleToStr(profit*PPips*Lot_01, 2), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_142", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_142", OBJPROP_XDISTANCE, X04+StepX04);
   ObjectSet      ("i-NASA4_142", OBJPROP_YDISTANCE, Y01+3*StepY);

   ObjectCreate   ("i-NASA4_143", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_143", DoubleToStr(profit*PPips*Lot_02, 2), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_143", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_143", OBJPROP_XDISTANCE, X04+StepX04+StepX05);
   ObjectSet      ("i-NASA4_143", OBJPROP_YDISTANCE, Y01+3*StepY);

   ObjectCreate   ("i-NASA4_144", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_144", DoubleToStr(profit*PPips*Lot_03, 2), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_144", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_144", OBJPROP_XDISTANCE, X04+StepX04+2*StepX05);
   ObjectSet      ("i-NASA4_144", OBJPROP_YDISTANCE, Y01+3*StepY);

   ObjectCreate   ("i-NASA4_145", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_145", DoubleToStr(profit*PPips*Lot_04, 2), FontSize, FontName, Color2);
   ObjectSet      ("i-NASA4_145", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_145", OBJPROP_XDISTANCE, X04+StepX04+3*StepX05);
   ObjectSet      ("i-NASA4_145", OBJPROP_YDISTANCE, Y01+3*StepY);

   ObjectCreate   ("i-NASA4_242", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_242", " ("+DoubleToStr(pips_01*PPips, 2)+"%)", FontSize, FontName, Color4);
   ObjectSet      ("i-NASA4_242", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_242", OBJPROP_XDISTANCE, X04+StepX04+StepX06);
   ObjectSet      ("i-NASA4_242", OBJPROP_YDISTANCE, Y01+3*StepY);

   ObjectCreate   ("i-NASA4_243", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_243", " ("+DoubleToStr(pips_02*PPips, 2)+"%)", FontSize, FontName, Color4);
   ObjectSet      ("i-NASA4_243", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_243", OBJPROP_XDISTANCE, X04+StepX04+StepX05+StepX06);
   ObjectSet      ("i-NASA4_243", OBJPROP_YDISTANCE, Y01+3*StepY);

   ObjectCreate   ("i-NASA4_244", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_244", " ("+DoubleToStr(pips_03*PPips, 2)+"%)", FontSize, FontName, Color4);
   ObjectSet      ("i-NASA4_244", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_244", OBJPROP_XDISTANCE, X04+StepX04+2*StepX05+StepX06);
   ObjectSet      ("i-NASA4_244", OBJPROP_YDISTANCE, Y01+3*StepY);

   ObjectCreate   ("i-NASA4_245", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_245", " ("+DoubleToStr(pips_04*PPips, 2)+"%)", FontSize, FontName, Color4);
   ObjectSet      ("i-NASA4_245", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_245", OBJPROP_XDISTANCE, X04+StepX04+3*StepX05+StepX06);
   ObjectSet      ("i-NASA4_245", OBJPROP_YDISTANCE, Y01+3*StepY);
//====      ====
   ObjectCreate   ("i-NASA4_151", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_151", "   :", FontSize, FontName, Color1);
   ObjectSet      ("i-NASA4_151", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_151", OBJPROP_XDISTANCE, X04);
   ObjectSet      ("i-NASA4_151", OBJPROP_YDISTANCE, Y01+4*StepY);

   ObjectCreate   ("i-NASA4_152", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_152", DoubleToStr(PipsPlus_01, 0)+" ( "+DoubleToStr((PlusMinus_01), 0)+")", FontSize, FontName, ColorPips);
   ObjectSet      ("i-NASA4_152", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_152", OBJPROP_XDISTANCE, X04+StepX04);
   ObjectSet      ("i-NASA4_152", OBJPROP_YDISTANCE, Y01+4*StepY);

   ObjectCreate   ("i-NASA4_153", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_153", DoubleToStr(PipsPlus_02, 0)+" ( "+DoubleToStr((PlusMinus_02), 0)+")", FontSize, FontName, ColorPips);
   ObjectSet      ("i-NASA4_153", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_153", OBJPROP_XDISTANCE, X04+StepX04+StepX05);
   ObjectSet      ("i-NASA4_153", OBJPROP_YDISTANCE, Y01+4*StepY);

   ObjectCreate   ("i-NASA4_154", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_154", DoubleToStr(PipsPlus_03, 0)+" ( "+DoubleToStr((PlusMinus_03), 0)+")", FontSize, FontName, ColorPips);
   ObjectSet      ("i-NASA4_154", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_154", OBJPROP_XDISTANCE, X04+StepX04+2*StepX05);
   ObjectSet      ("i-NASA4_154", OBJPROP_YDISTANCE, Y01+4*StepY);

   ObjectCreate   ("i-NASA4_155", OBJ_LABEL, WindowFind(ShortName), 0, 0);
   ObjectSetText  ("i-NASA4_155", DoubleToStr(PipsPlus_04, 0)+" ( "+DoubleToStr((PlusMinus_04), 0)+")", FontSize, FontName, ColorPips);
   ObjectSet      ("i-NASA4_155", OBJPROP_CORNER, 0);
   ObjectSet      ("i-NASA4_155", OBJPROP_XDISTANCE, X04+StepX04+3*StepX05);
   ObjectSet      ("i-NASA4_155", OBJPROP_YDISTANCE, Y01+4*StepY);
//====
   return(0);
   }
//+------------------------------------------------------------------+
//| Objects delete function                                          |
//+------------------------------------------------------------------+
void DeleteObjects()
   {
   for(int i=ObjectsTotal();i>=0;i--)
      {
      if(StringSubstr(ObjectName(i),0,6)=="i-NASA3_")
      ObjectDelete(ObjectName(i));
      }
   }
//+------------------------------------------------------------------+
//| Objects color modify function ( x < 0 < x )                      |
//+------------------------------------------------------------------+
color ColorZero(double bigg)
   {
   color ColorModify = Color1;
      if (bigg>0)    ColorModify = Color2;
      if (bigg<0)    ColorModify = Color3;
      if (bigg==0)   ColorModify = Color4;
   return(ColorModify);
   }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :                        |
//|                                            |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -               (""   -  ,         |
//|                                               NULL -  )       |
//|    op -                              (-1   -  )        |
//|    mn - MagicNumber                          (-1   -  )          |
//|    dt -       1970   ( 0   -   )     |
//+----------------------------------------------------------------------------+
double GetProfitFromDateInCurrency(string sy="", int op=-1, int mn=-1, datetime dt=0)
{
  double p=0;
  int    i, k=OrdersHistoryTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (dt<OrderCloseTime()) {
              p+=OrderProfit()+OrderCommission()+OrderSwap();
            }
          }
        }
      }
    }
  }
  return(p);
}
//+----------------------------------------------------------------------------+